Index: /t3lib/class.t3lib_tceforms.php
===================================================================
--- /t3lib/class.t3lib_tceforms.php	(revision 2614)
+++ /t3lib/class.t3lib_tceforms.php	(working copy)
@@ -641,18 +641,19 @@
 
 				// Create parts array for the tab menu:
 			$parts = array();
-			foreach ($out_array as $idx => $sheetContent)	{
-				$resstr = implode('', $sheetContent);
-				if ($resstr) {
-					$parts[$idx] = array(
-						'label' => $out_array_meta[$idx]['title'],
-						'content' => '<table border="0" cellspacing="0" cellpadding="0" width="100%">'.
-								$resstr.
-							'</table>'
-					);
+			foreach ($out_array as $idx => $sheetContent)	{				
+				$sContent = implode('', $sheetContent);
+				if ($sContent) {
+					$sContent = '<table border="0" cellspacing="0" cellpadding="0" width="100%">'.$sContent.'</table>';
 				}
+				$parts[$idx] = array(
+					'label' => $out_array_meta[$idx]['title'],
+					'content' => $sContent,
+				);
 			}
+			
 
+
 			if (count($parts) > 1) {
 					// Unset the current level of tab menus:
 				$this->popFromDynNestedStack('tab', $tabIdentStringMD5.'-'.($out_sheet+1));
Index: /typo3/template.php
===================================================================
--- /typo3/template.php	(revision 2614)
+++ /typo3/template.php	(working copy)
@@ -1730,50 +1730,47 @@
 
 				$isActive = strcmp(trim($def['content']),'');
 
-				if ($isActive) {
+				$mouseOverOut = ' onmouseover="DTM_mouseOver(this);" onmouseout="DTM_mouseOut(this);"';
 
-					$mouseOverOut = ' onmouseover="DTM_mouseOver(this);" onmouseout="DTM_mouseOut(this);"';
-
-					if (!$foldout)	{
-							// Create TAB cell:
-						$options[$tabRows][] = '
-								<td class="'.($isActive ? 'tab' : 'disabled').'" id="'.$id.'-'.$index.'-MENU"'.$noWrap.$mouseOverOut.'>'.
-								($isActive ? '<a href="#" onclick="'.htmlspecialchars($onclick).'"'.($def['linkTitle'] ? ' title="'.htmlspecialchars($def['linkTitle']).'"':'').'>' : '').
-								$def['icon'].
-								($def['label'] ? htmlspecialchars($def['label']) : '&nbsp;').
-								$this->icons($def['stateIcon'],'margin-left: 10px;').
-								($isActive ? '</a>' :'').
-								'</td>';
-						$titleLenCount+= strlen($def['label']);
-					} else {
-							// Create DIV layer for content:
-						$divs[] = '
-							<div class="'.($isActive ? 'tab' : 'disabled').'" id="'.$id.'-'.$index.'-MENU"'.$mouseOverOut.'>'.
-								($isActive ? '<a href="#" onclick="'.htmlspecialchars($onclick).'"'.($def['linkTitle'] ? ' title="'.htmlspecialchars($def['linkTitle']).'"':'').'>' : '').
-								$def['icon'].
-								($def['label'] ? htmlspecialchars($def['label']) : '&nbsp;').
-								($isActive ? '</a>' : '').
-								'</div>';
-					}
-
+				if (!$foldout)	{
+						// Create TAB cell:
+					$options[$tabRows][] = '
+							<td class="'.($isActive ? 'tab' : 'disabled').'" id="'.$id.'-'.$index.'-MENU"'.$noWrap.$mouseOverOut.'>'.
+							($isActive ? '<a href="#" onclick="'.htmlspecialchars($onclick).'"'.($def['linkTitle'] ? ' title="'.htmlspecialchars($def['linkTitle']).'"':'').'>' : '').
+							$def['icon'].
+							($def['label'] ? htmlspecialchars($def['label']) : '&nbsp;').
+							$this->icons($def['stateIcon'],'margin-left: 10px;').
+							($isActive ? '</a>' :'').
+							'</td>';
+					$titleLenCount+= strlen($def['label']);
+				} else {
 						// Create DIV layer for content:
 					$divs[] = '
-							<div style="display: none;" id="'.$id.'-'.$index.'-DIV" class="c-tablayer">'.
-								($def['description'] ? '<p class="c-descr">'.nl2br(htmlspecialchars($def['description'])).'</p>' : '').
-								$def['content'].
-								'</div>';
-						// Create initialization string:
+						<div class="'.($isActive ? 'tab' : 'disabled').'" id="'.$id.'-'.$index.'-MENU"'.$mouseOverOut.'>'.
+							($isActive ? '<a href="#" onclick="'.htmlspecialchars($onclick).'"'.($def['linkTitle'] ? ' title="'.htmlspecialchars($def['linkTitle']).'"':'').'>' : '').
+							$def['icon'].
+							($def['label'] ? htmlspecialchars($def['label']) : '&nbsp;').
+							($isActive ? '</a>' : '').
+							'</div>';
+				}
+
+					// Create DIV layer for content:
+				$divs[] = '
+						<div style="display: none;" id="'.$id.'-'.$index.'-DIV" class="c-tablayer">'.
+							($def['description'] ? '<p class="c-descr">'.nl2br(htmlspecialchars($def['description'])).'</p>' : '').
+							$def['content'].
+							'</div>';
+					// Create initialization string:
+				$JSinit[] = '
+						DTM_array["'.$id.'"]['.$c.'] = "'.$id.'-'.$index.'";
+				';
+				if ($toggle==1)	{
 					$JSinit[] = '
-							DTM_array["'.$id.'"]['.$c.'] = "'.$id.'-'.$index.'";
+						if (top.DTM_currentTabs["'.$id.'-'.$index.'"]) { DTM_toggle("'.$id.'","'.$index.'",1); }
 					';
-					if ($toggle==1)	{
-						$JSinit[] = '
-							if (top.DTM_currentTabs["'.$id.'-'.$index.'"]) { DTM_toggle("'.$id.'","'.$index.'",1); }
-						';
-					}
+				}
 
-					$c++;
-				}
+				$c++;
 			}
 
 				// Render menu:
@@ -1851,7 +1848,10 @@
 						for(cnt = 0; cnt < DTM_array[idBase].length ; cnt++)	{
 							if (DTM_array[idBase][cnt] != idBase+"-"+index)	{
 								document.getElementById(DTM_array[idBase][cnt]+"-DIV").style.display = "none";
-								document.getElementById(DTM_array[idBase][cnt]+"-MENU").attributes.getNamedItem("class").nodeValue = "tab";
+								// Only Overriding when Tab not disabled
+								if (document.getElementById(DTM_array[idBase][cnt]+"-MENU").attributes.getNamedItem("class").nodeValue != "disabled") {
+									document.getElementById(DTM_array[idBase][cnt]+"-MENU").attributes.getNamedItem("class").nodeValue = "tab";
+								}
 							}
 						}
 					}
Index: /typo3/sysext/t3skin/stylesheets/typo3-dyntabmenu.css
===================================================================
--- /typo3/sysext/t3skin/stylesheets/typo3-dyntabmenu.css	(revision 2614)
+++ /typo3/sysext/t3skin/stylesheets/typo3-dyntabmenu.css	(working copy)
@@ -19,7 +19,8 @@
 
 table.typo3-dyntabmenu td {
 	color: #E6E1B2;
-	border:0;
+	border: solid 1px #A2AAB8;
+	border-bottom: 0;
 	padding: 0;
 	cursor: pointer;
 	}
@@ -33,14 +34,13 @@
 		}
 
 	table.typo3-dyntabmenu td.disabled,
-	table.typo3-dyntabmenu td.disabled:hover {
+	table.typo3-dyntabmenu td.disabled_over {
+		padding: 5px 10px 5px 10px;
 		color: #A2AAB8;
 		background-color: #EFEFF4;
 		}
 
 table.typo3-dyntabmenu td a {
-	border: solid 1px #A2AAB8;
-	border-bottom: 0;
 	padding: 5px 10px 5px 10px;
 	display: block;
 	width: auto;